
#ifndef SAMPLE_H
#define SAMPLE_H


/* GLOBAL double **qq;         */        /* moved to globs.h (Qq)      */ 
                              /* array of allele freqs at all the loci */
GLOBAL int **xx0, **xx1;      /* arrays of maternal and paternal 
                                 segregation indicators at all the loci*/
GLOBAL int **gg0, **gg1;      /* arrays of all labelled founder genes  
                                 in the pedigree */
GLOBAL int lpflag[3][3][NLOC];  /* flags set by set_chromosomes to indicate
                                    when log-probs may differ and must be
                                    included in prob ratio */

extern void allocate_loci(int,int *,double **);
extern int check_seg_mode(void);
extern void set_seg_mode(int);
extern int set_genes(int);
extern double seg_pen2(int,int ***,double *,int,int,int *);

#endif

