

  /*****************************************************************
         * M-Sample Step     EAT 1997                              *
         *   to subroutine   EAT March 2000                        *
         ****************************************************************/
#include "msample.h"

void do_msmpl (int nl, int c, int i, int sx,
         double prob[NC][NLOC], int ***y, int ng)
  {  int  j, jj, ix, err;
     int xx=0, **xxx, new_segs[NLOC];
     double rr;

     
     double pp2[NLOC][2];              /* penetrance probabilities at each
                                          locus under proposed values for
                                           switching given
                                           meiosis in given component */
     double pcf[NLOC][2];     /* cumulative peeling probs along chromosome */

     ix = 2-sx;
     if (sx==0) xxx=xx0; else xxx=xx1;

                        /* store current penetrance values in pp2,
                           make switches, and store new penetrance values */
   for (jj= 0; jj <= nl; ++jj)
        { pp2[jj][xxx[jj][i]] = prob[c][jj];
          xxx[jj][i] = 1 - xxx[jj][i];

          gene_update(jj,i,sx);
          pp2[jj][xxx[jj][i]] =  seg_pen2(c, y ,Qq[jj], jj, ng, &err );
          prob[c][jj] = pp2[jj][xxx[jj][i]];
         }

                        /* compute P(S_j | Y_1, ..., Y_j) by "peeling" */
   for (j= 0; j<= nl; ++j)
      { jj = chromo[0][j];  rr = xecomo[ix][0][j-1];
        fwd_compute (j, rr, pp2[jj], pcf[j-1], pcf[j] ); }

                        /* sample new indicators by "reverse peeling" */

 for (j= nl ; j >= 0; --j)
      {   rr = xecomo[ix][0][j];
          xx  = back_sample (nl, j, xx, rr, pcf[j][0] );
          new_segs[j] = xx; 
       }

   for (j= nl ; j >= 0; --j)
        { xx = new_segs[j];

          jj = chromo[0][j];
       if (xx != xxx[jj][i])
              { xxx[jj][i] = xx;
                gene_update(jj,i,sx);
                prob[c][jj] = seg_pen2(c, y ,Qq[jj], jj, ng, &err ); }
       }
    return ;

    }

