
#include "stuff.h"

/****************************************************************************

  name: stamp_time.c

  purpose: stamp the date and time the program is executed and the elapsed
           time.

  date: 11/30/90 program written by Sun Wei Guo.
  Corrected and installed in this library,  5/9/92  (Elizabeth Thompson)

****************************************************************************/

void stamp_time (time_t t1 )
	
{ time_t t2, now;
  int hr, min, sec;

  hr = min = 0; sec=0;
  time(&t2);
  t2 -= t1;

  time(&now);

  hr = t2 / 3600;

  if ( t2 >= 3600 * hr )
    t2 -= 3600 * hr;

  min = t2 / 60 ;

  if ( t2 >= 60 * min )
    t2 -= 60 * min;

  sec = t2;

  printf("Total elapsed time: %3d hr(s) %3d min %3d sec\n",hr,min,sec);
  printf("Date and time: %s\n", ctime(&now));

}

